Subject: Re: [PATCH v2 0/7] gitweb: fix "make" not including "gitweb" without NOOP run slowdowns

From: Junio C Hamano <[email-masked]>
Date: Thu, 23 Jun 2022 16:25:51 -0700

Ævar Arnfjörð Bjarmason <[email-masked]> writes:

>> We could easily add "cd .. && make gitweb" to gitweb/Makefile with
>> the same "minor hassle" but that needs to be done just once, instead
>> of having to be done once per packager, so I am not sure the above
>> argues for a good tradeoff.
>
> True, but I think critically in this case we've never documented that
> you should be running gitweb/Makefile directly. I.e. the gitweb/INSTALL
> has always documented and assumed that you run these from the top-level.

Well, I do not think Makefiles document much of their targets in
general.  If its first/default target has a reasonable name, like
"all", people expect "cd there && make all" would do the right
thing.

So I do not think "we never documented" is a good excuse.  What the
current users have been doing and are expecting to keep working is
what counts.  If they are used to see "cd gitweb && make" working,
perhaps instead of giving an unfriendly $(error do not run) at the
beginning of gitweb/Makefile that is designed to trigger only when
they did that (instead of running 'make gitweb' from the top), it
would be trivial to have the rule to "cd .. && $(MAKE) gitweb"
there, no?